<?php
namespace MascotCoreEcoifeWP\Widgets\WPCF;

use Elementor\Plugin;
use Elementor\Widget_Base;
use Elementor\Controls_Manager;

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

/**
 * Elementor Hello World
 *
 * Elementor widget for hello world.
 *
 * @since 1.0.0
 */
class TM_Elementor_WPCF_Base extends Widget_Base {
	public function get_name() {
		return 'tm-ele-wpcf-donate-btn333';
	}

	private function get_preview_post_default($post_type){
		$query_args = [
			'post_type'          => 'product',
			'posts_per_page'     => 1,
			'numberposts'        => 1,
			'post_status'        => 'publish',
			'orderby'            => 'ID',
			'order'              => 'desc'
		];
		$taxquery = array(
			array(
				'taxonomy' => 'product_type',
				'field' => 'slug',
				'terms' => 'crowdfunding',
			)
		);
		$query_args['tax_query'] = $taxquery;

		$query = new \WP_Query($query_args);
		$post_id = 0;
		 foreach ($query->posts as $post) {
			if($post->ID > 0){
				$post_id = $post->ID;
			}
		}
		wp_reset_postdata();
		return $post_id;
	}

	/**
	 * Render the widget output on the frontend.
	 *
	 * Written in PHP and used to generate the final HTML.
	 *
	 * @since 1.0.0
	 *
	 * @access protected
	 */
	protected function render() {

		global $funden_post, $post, $funden_term_id;
		
		$post_type = get_post_type();
		$post_id = get_the_ID();
		if ($post_type === 'wpcf-single-template' || $post_type === 'elementor_library'){
			
			$document = Plugin::instance()->documents->get($post_id);
			$template_type = get_post_meta(get_the_ID(), 'gva_template_type', true);

			$preview_post_id = 0;
			$funden_term_id = 0;
			$post_preview = $document->get_settings('funden_post_preview');

			$preview_post_id = $post_preview ? $post_preview : $this->get_preview_post_default('crowdfunding');

			$funden_post = get_post($preview_post_id);
		}else{
			$funden_post = $post;

			//term_id
			$object = get_queried_object();
			if(!empty($object)){
				 $funden_term_id = isset($object->term_id) && $object->term_id ? $object->term_id : 0;
			}
		}
	}
}
